## mingw-w64-qt-creator-18.0.0-1.src.tar.zst

=== src/plugins/copilot/CMakeLists.txt ===
add_qtc_plugin(Copilot
  PLUGIN_DEPENDS Core LanguageClient
  LONG_DESCRIPTION_MD Description.md
  SOURCES
    authwidget.cpp authwidget.h
    copilot.qrc
    copilotclient.cpp copilotclient.h
    copilotconstants.h
    copilotplugin.cpp
    copilotprojectpanel.cpp copilotprojectpanel.h
    copilotsettings.cpp copilotsettings.h
    requests/checkstatus.h
    requests/getcompletions.h
    requests/signinconfirm.h
    requests/signininitiate.h
    requests/signout.h
)

=== src/plugins/designer/CMakeLists.txt ===
# used in the .json.in
if(Qt6_VERSION VERSION_GREATER_EQUAL 6.7.0)
  set(DESIGNER_PLUGIN_ARGUMENTS
  "\"Arguments\" : [
    {
        \"Name\" : \"-designer-qt-pluginpath\",
        \"Parameter\" : \"path\",
        \"Description\" : \"Override the default search path for Qt Widgets Designer plugins\"
    },
    {
        \"Name\" : \"-designer-pluginpath\",
        \"Parameter\" : \"path\",
        \"Description\" : \"Add a custom search path for Qt Widgets Designer plugins\"
    }
    ],")
else()
  set(DESIGNER_PLUGIN_ARGUMENTS
  "\"Arguments\" : [
    {
        \"Name\" : \"-designer-qt-pluginpath\",
        \"Parameter\" : \"path\",
        \"Description\" : \"Override the default search path for Qt Widgets Designer plugins\"
    }
    ],")
endif()

add_qtc_plugin(Designer
  PLUGIN_CLASS DesignerPlugin
  CONDITION TARGET Qt::DesignerComponentsPrivate AND TARGET Qt::Designer
  DEPENDS designerintegrationv2
    Qt::Designer Qt::PrintSupport Qt::DesignerComponentsPrivate
  PLUGIN_DEPENDS Core CppEditor ProjectExplorer QtSupport ResourceEditor TextEditor
  PLUGIN_TEST_DEPENDS CppEditor
  SOURCES
    codemodelhelpers.cpp codemodelhelpers.h
    cpp/formclasswizard.cpp cpp/formclasswizard.h
    cpp/formclasswizarddialog.cpp cpp/formclasswizarddialog.h
    cpp/formclasswizardpage.cpp cpp/formclasswizardpage.h
    cpp/formclasswizardparameters.cpp cpp/formclasswizardparameters.h
    cpp/newclasswidget.cpp cpp/newclasswidget.h
    designer_export.h
    designerconstants.h
    designerplugin.cpp
    designertr.h
    editordata.h
    editorwidget.cpp editorwidget.h
    formeditorfactory.cpp formeditorfactory.h
    formeditorstack.cpp formeditorstack.h
    formeditor.cpp formeditor.h
    formtemplatewizardpage.cpp formtemplatewizardpage.h
    formwindoweditor.cpp formwindoweditor.h
    formwindowfile.cpp formwindowfile.h
    qtcreatorintegration.cpp qtcreatorintegration.h
    qtdesignerformclasscodegenerator.cpp qtdesignerformclasscodegenerator.h
    resourcehandler.cpp resourcehandler.h
    settingsmanager.cpp settingsmanager.h
    settingspage.cpp settingspage.h
)

extend_qtc_plugin(Designer
  CONDITION WITH_TESTS
  SOURCES gotoslot_test.cpp
)

if (QTC_STATIC_BUILD AND TARGET Designer)
  # version-less target Qt::Designer is an interface library that links to QtX::Designer
  get_target_property(_designer Qt::Designer INTERFACE_LINK_LIBRARIES)
  get_target_property(_designerType ${_designer} TYPE)
  if (${_designerType} STREQUAL "STATIC_LIBRARY")
    extend_qtc_target(Designer PUBLIC_DEFINES QT_DESIGNER_STATIC)
  endif()
endif()

=== src/plugins/qmljstools/CMakeLists.txt ===
add_qtc_plugin(QmlJSTools
  DEPENDS LanguageUtils
  PUBLIC_DEPENDS QmlJS
  PLUGIN_DEPENDS Core CppEditor ProjectExplorer QtSupport TextEditor
  SOURCES
    qmlformatsettings.cpp qmlformatsettings.h
    qmljsbundleprovider.cpp qmljsbundleprovider.h
    qmljscodestylepreferenceswidget.cpp qmljscodestylepreferenceswidget.h
    qmljscodestylesettings.cpp qmljscodestylesettings.h
    qmljscustomformatterwidget.cpp qmljscustomformatterwidget.h
    qmlformatsettingswidget.cpp qmlformatsettingswidget.h
    qmljsformatterselectionwidget.cpp qmljsformatterselectionwidget.h
    qmljsfunctionfilter.cpp qmljsfunctionfilter.h
    qmljsindenter.cpp qmljsindenter.h
    qmljsmodelmanager.cpp qmljsmodelmanager.h
    qmljsqtstylecodeformatter.cpp qmljsqtstylecodeformatter.h
    qmljsrefactoringchanges.cpp qmljsrefactoringchanges.h
    qmljssemanticinfo.cpp qmljssemanticinfo.h
    qmljstools.qrc
    qmljstools_global.h
    qmljstoolstr.h
    qmljstoolsconstants.h
    qmljstoolsplugin.cpp
    qmljstoolssettings.cpp qmljstoolssettings.h
)

extend_qtc_plugin(QmlJSTools
  CONDITION WITH_TESTS
  SOURCES
    qmljstools_test.cpp
    qmljstools_test.h
)

=== src/tools/sdktool/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../../../cmake")

project(qtsdktool)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

if (NOT QT_CREATOR_API_DEFINED)
  # standalone build
  set(DESTINATION DESTINATION .)
  set(QTC_SBOM_READY ON)
  include(QtCreatorIDEBranding)
  include(QtCreatorAPI)
  include(QtCreatorSbom)
  qtc_handle_compiler_cache_support()

  find_package(QT NAMES Qt6 Qt5
    COMPONENTS Core
    REQUIRED
  )
  find_package(Qt${QT_VERSION_MAJOR}
    COMPONENTS Core
    REQUIRED
  )
  set(QT_SDK_TOOL_STANDALONE_BUILD TRUE)
  qtc_setup_sbom()
  qtc_sbom_compute_cpe(project_cpe
      VENDOR "qt"
      PRODUCT "${PROJECT_NAME}"
      VERSION "${IDE_VERSION}"
  )
  set(QT_SBOM_LICENSE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/../../../LICENSES")
  qtc_sbom_begin_project(
    PURL_NAMESPACE "qt"
    PURL_NAME "${PROJECT_NAME}"
    CPE "${project_cpe}"
  )
endif()

configure_file(../../app/app_version.h.cmakein app/app_version.h ESCAPE_QUOTES)

if (APPLE)
  find_library(FWFoundation Foundation)
endif()

set(UtilsSourcesDir "../../libs/utils")

file(RELATIVE_PATH DATA_PATH "/${IDE_LIBEXEC_PATH}" "/${IDE_DATA_PATH}")

add_qtc_library(sdktoolLib
  STATIC
  DEFINES DATA_PATH=\"${DATA_PATH}\"
  PUBLIC_DEPENDS Qt::Core
  PUBLIC_INCLUDES ${CMAKE_CURRENT_SOURCE_DIR} "${UtilsSourcesDir}/../"
  INCLUDES
    ${CMAKE_CURRENT_BINARY_DIR}
  SOURCES
    addabiflavor.cpp addabiflavor.h
    addcmakeoperation.cpp addcmakeoperation.h
    adddebuggeroperation.cpp adddebuggeroperation.h
    adddeviceoperation.cpp adddeviceoperation.h
    addkeysoperation.cpp addkeysoperation.h
    addkitoperation.cpp addkitoperation.h
    addqtoperation.cpp addqtoperation.h
    addtoolchainoperation.cpp addtoolchainoperation.h
    addvalueoperation.cpp addvalueoperation.h
    findkeyoperation.cpp findkeyoperation.h
    findvalueoperation.cpp findvalueoperation.h
    getoperation.cpp getoperation.h
    operation.cpp operation.h
    rmcmakeoperation.cpp rmcmakeoperation.h
    rmdebuggeroperation.cpp rmdebuggeroperation.h
    rmdeviceoperation.cpp rmdeviceoperation.h
    rmkeysoperation.cpp rmkeysoperation.h
    rmkitoperation.cpp rmkitoperation.h
    rmqtoperation.cpp rmqtoperation.h
    rmtoolchainoperation.cpp rmtoolchainoperation.h
    settings.cpp settings.h
    sdkpersistentsettings.cpp sdkpersistentsettings.h
)

if (MSVC)
    find_library(DbgHelpLib dbghelp)
endif()

extend_qtc_library(sdktoolLib CONDITION MSVC
  DEPENDS ${DbgHelpLib}
)
extend_qtc_library(sdktoolLib CONDITION WIN32
  PUBLIC_DEPENDS
    user32 iphlpapi ws2_32 shell32
  DEFINES
    _UNICODE UNICODE
    _CRT_SECURE_NO_WARNINGS _SCL_SECURE_NO_WARNINGS
)

add_qtc_executable(sdktool
  ${DESTINATION}
  DEFINES DATA_PATH=\"${DATA_PATH}\"
  DEPENDS sdktoolLib
  INCLUDES
    ${CMAKE_CURRENT_BINARY_DIR}
  SOURCES
    main.cpp
)

if (MSVC AND TARGET sdktool AND TARGET Qt5::Core)
  # find out if Qt is static and set /MT if so
  get_target_property(_input_type Qt5::Core TYPE)
  if (${_input_type} STREQUAL "STATIC_LIBRARY")
    set_property(TARGET sdktool PROPERTY MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
    set_property(TARGET sdktoolLib PROPERTY MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
  endif()
endif()

if(QT_SDK_TOOL_STANDALONE_BUILD)
  qtc_sbom_end_project()
endif()

=== tests/manual/docker/Makefile ===
all: help

help:
	@grep -E '^[0-9a-zA-Z._-]+:.*?## .*$$' $(MAKEFILE_LIST) | awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-30s\033[0m %s\n", $$1, $$2}'

default_run_args = --env="DISPLAY=host.docker.internal:0" --cap-add=SYS_PTRACE --security-opt seccomp=unconfined -v $(HOME):$(HOME) --workdir=$(HOME)

base: Dockerfile-base ## Build Ubuntu 25.10, docker-cli image, build Qt manually
	docker build . -f Dockerfile-base -t qt-linux-base -t qt-linux-base:6

base-run: ## Build & run the base image
	docker run -it --rm -v /var/run/docker.sock:/var/run/docker.sock $(default_run_args) qt-linux-base /bin/bash

qt-linux-x86: Dockerfile ## Build Ubuntu 25.10, Qt 6, docker-cli image (For x86_64)
	docker build . --platform=linux/amd64 -t qt-linux-x86_64 -t qt-linux-x86_64:6

qt-linux: Dockerfile ## Build Ubuntu 25.10, Qt 6, docker-cli image
	docker build . -t qt-linux -t qt-linux:6

qt-linux-run: qt-linux ## Build & run the image
	docker run -it --rm -v /var/run/docker.sock:/var/run/docker.sock $(default_run_args) qt-linux:6 /bin/bash

qt-linux-with-qtc: DockerFile-with-creator ## Build Ubuntu 25.10, Qt 6, docker-cli image, Includes Qt Creator
	docker build . -f DockerFile-with-creator -t qt-linux-qtc -t qt-linux-qtc:6

qt-linux-with-qtc-run: qt-linux-with-qtc ## Build & run the image, Includes Qt Creator
	docker run -it --rm  $(default_run_args) qt-linux-qtc:6 /bin/bash	

qt-linux-with-llvm: Dockerfile-llvm ## Build Ubuntu 25.10, Qt 6, docker-cli image, With Clang
	docker build . -f Dockerfile-llvm -t qt-linux-llvm -t qt-linux-llvm:6

qt-linux-with-llvm-run: qt-linux-with-llvm ## Build & run the image, With Clang
	docker run -it --rm  $(default_run_args) qt-linux-llvm:6 /bin/bash

qt-linux-with-llvm-conan: Dockerfile-llvm-conan ## Build Ubuntu 25.10, Qt 6, docker-cli image, With Clang, Conan
	docker build . -f Dockerfile-llvm-conan -t qt-linux-llvm-conan -t qt-linux-llvm-conan:6

qt-linux-with-llvm-conan-run: qt-linux-with-llvm-conan ## Build & run the image, With Clang, Conan
	docker run -it --rm  $(default_run_args) qt-linux-llvm-conan:6 /bin/bash

qt-linux-with-llvm-vcpkg: Dockerfile-llvm-vcpkg ## Build Ubuntu 25.10, Qt 6, docker-cli image, With Clang, Vcpkg
	docker build . -f Dockerfile-llvm-vcpkg -t qt-linux-llvm-vcpkg -t qt-linux-llvm-vcpkg:6

qt-linux-with-llvm-vcpkg-run: qt-linux-with-llvm-vcpkg ## Build & run the image, With Clang, Vcpkg
	docker run -it --rm  $(default_run_args) qt-linux-llvm-vcpkg:6 /bin/bash

qt-linux-with-gcc-10: Dockerfile-gcc-10 ## Build Ubuntu 25.10, Qt 6, docker-cli image, With GCC 10
	docker build . -f Dockerfile-gcc-10 -t qt-linux-gcc-10 -t qt-linux-gcc-10:6
qt-linux-with-gcc-10-run: qt-linux-with-gcc-10 ## Build & run the image, With GCC 10
	docker run -it --rm  $(default_run_args) qt-linux-gcc-10:6 /bin/bash

pyside6-ubuntu: Dockerfile-pyside6-ubuntu ## Build Ubuntu latest, PySide6 image
	docker build . -f Dockerfile-pyside6-ubuntu -t pyside6-ubuntu

qt-5-ubuntu-16.04-build: Dockerfile-qt-5-ubuntu-16.04-build ## Build-Image, Ubuntu 16.04, Qt 5 image
	docker build . -f Dockerfile-qt-5-ubuntu-16.04-build -t qt-5-ubuntu-16.04-build

qt-5-ubuntu-20.04-build: Dockerfile-qt-5-ubuntu-20.04-build ## Build-Image, Ubuntu 20.04, Qt 5 image
	docker build . -f Dockerfile-qt-5-ubuntu-20.04-build -t qt-5-ubuntu-20.04-build

qt-5-ubuntu-20.04-run: Dockerfile-qt-5-ubuntu-20.04-run ## Run-Image, Ubuntu 20.04, Qt 5 image
	docker build . -f Dockerfile-qt-5-ubuntu-20.04-run -t qt-5-ubuntu-20.04-run

qt-5-ubuntu-20.04-clang-lldb-build: Dockerfile-qt-5-ubuntu-20.04-clang-lldb-build ## Build-Image, Ubuntu 20.04, Qt 5 image, with Clang and LLDB
	docker build . -f Dockerfile-qt-5-ubuntu-20.04-clang-lldb-build -t qt-5-ubuntu-20.04-clang-lldb-build

qt-6-fedora-37-build: Dockerfile-qt-6-fedora-37-build ## Build-Image, Fedora 37, Qt 6 image
	docker build . -f Dockerfile-qt-6-fedora-37-build -t qt-6-fedora-37-build

qt-6-ubuntu-24.04-build: Dockerfile-qt-6-ubuntu-24.04-build ## Build-Image, Ubuntu 24.04, Qt 6 image, With qbs
	docker build . -f Dockerfile-qt-6-ubuntu-24.04-build -t qt-6-ubuntu-24.04-build

build: qt-5-ubuntu-16.04-build qt-5-ubuntu-20.04-build qt-5-ubuntu-20.04-run qt-5-ubuntu-20.04-clang-lldb-build qt-6-fedora-37-build qt-6-ubuntu-24.04-build ## Old build.sh targets

=== src/libs/3rdparty/qtkeychain/CMakeLists.txt ===
add_qtc_library(qtkeychain
  DEPENDS Qt::Core
  SOURCES
    keychain.cpp keychain.h
    qkeychain_export.h
  PROPERTIES
    QT_COMPILE_OPTIONS_DISABLE_WARNINGS ON
  SBOM_ARGS
    SBOM_ENTITY_TYPE THIRD_PARTY_LIBRARY_WITH_FILES
    USE_ATTRIBUTION_FILES
    ATTRIBUTION_FILE_PATHS
      "${QtCreator_SOURCE_DIR}/qt_attributions.json"
    ATTRIBUTION_IDS
      qtkeychain
)

if (WIN32)
  option(USE_CREDENTIAL_STORE "Build with windows CredentialStore support" ON)

  extend_qtc_library(qtkeychain SOURCES keychain_win.cpp)

  extend_qtc_library(qtkeychain
    CONDITION USE_CREDENTIAL_STORE
    FEATURE_INFO "CredentialStore keychain support"
    DEFINES USE_CREDENTIAL_STORE=1
  )
  extend_qtc_library(qtkeychain
    CONDITION NOT USE_CREDENTIAL_STORE
    SOURCES plaintextstore.cpp
    DEPENDS crypt32
  )
endif()

extend_qtc_library(qtkeychain
  CONDITION APPLE
  SOURCES keychain_apple.mm
  DEPENDS ${FWFoundation} ${FWSecurity}
)

if (UNIX AND NOT APPLE)
    find_package(Qt6 COMPONENTS DBus)

    option(LIBSECRET_SUPPORT "Build with libsecret support if available" ON)
    if (LIBSECRET_SUPPORT)
      find_package(PkgConfig)

      include(FindPkgConfig)
      pkg_check_modules(LIBSECRET libsecret-1)

      extend_qtc_library(qtkeychain
        CONDITION LIBSECRET_FOUND
        FEATURE_INFO "libsecret keychain support"
        DEFINES HAVE_LIBSECRET=1
        INCLUDES ${LIBSECRET_INCLUDE_DIRS}
        DEPENDS ${LIBSECRET_LIBRARIES}
      )
    endif()

  qt6_add_dbus_interface(dbus_SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/org.kde.KWallet.xml kwallet_interface KWalletInterface)

  extend_qtc_library(qtkeychain
    CONDITION TARGET Qt::DBus
    FEATURE_INFO "keychain dbus support"
    DEFINES KEYCHAIN_DBUS=1
    DEPENDS Qt::DBus
    SOURCES
      keychain_unix.cpp
      libsecret.cpp
      plaintextstore.cpp
      ${dbus_SOURCES}
    )
endif()

=== src/shared/qbs/src/plugins/scanner/cpp/CMakeLists.txt ===
set(SOURCES
    ../scanner.h
    cpp_global.h
    cppscannerplugin.cpp
    )

add_qbs_plugin(qbs_cpp_scanner
    DEFINES "CPLUSPLUS_NO_PARSER"
    DEPENDS qbscore
    SOURCES ${SOURCES}
    )

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>
# Maintainer: Ray Donnelly <mingw.android@gmail.com>

_realname=qt-creator
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-docs"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-devel")
_base_ver=18.0.0
pkgver=${_base_ver/-/}
pkgrel=1
pkgdesc='Lightweight, cross-platform integrated development environment (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.qt.io/product/development-tools'
msys2_repository_url="https://code.qt.io/cgit/qt-creator/qt-creator.git"
msys2_references=(
  'archlinux: qtcreator'
)
license=('spdx:GPL-3.0-or-later WITH Qt-GPL-exception-1.0')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-clang"
             "${MINGW_PACKAGE_PREFIX}-clang-tools-extra"
             "${MINGW_PACKAGE_PREFIX}-go"
             "${MINGW_PACKAGE_PREFIX}-llvm"
             "${MINGW_PACKAGE_PREFIX}-litehtml"
             "${MINGW_PACKAGE_PREFIX}-python"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-qt6-tools"
             "${MINGW_PACKAGE_PREFIX}-qt6-svg"
             "${MINGW_PACKAGE_PREFIX}-qt6-quick3d"
             "${MINGW_PACKAGE_PREFIX}-qt6-serialport"
             "${MINGW_PACKAGE_PREFIX}-qt6-translations"
             "${MINGW_PACKAGE_PREFIX}-qt6-charts"
             "${MINGW_PACKAGE_PREFIX}-qt6-doc"
             "${MINGW_PACKAGE_PREFIX}-qt6-quicktimeline"
             "${MINGW_PACKAGE_PREFIX}-yaml-cpp")
install=qt-creator-${MSYSTEM}.install
_pkgfqn="${_realname}-opensource-src-${_base_ver}"
source=(https://download.qt.io/official_releases/qtcreator/${_base_ver%.*}/${_base_ver}/${_pkgfqn}.tar.xz
        qt-creator-3.2.0-Allow-iOS-plugin-on-any-platform.patch
        qt-creator-5.0.1-fix-library-archive-path.patch
        003-link-against-clang-cpp.patch
        qt-creator-18.0.0-plugin-appstatisticsmonitor-define-callback.patch)
sha256sums=('c773b74114d1fbca66c81b8fb799892827e7e1542491ed459aaad279e0253973'
            'eacd98f69324695595690c5328d62137af609e55c7c94c19e7bd8e1f7e4b4712'
            '29d67f88f071abe7a4b589182767b8a697fe4e516d70707bfca88f035883718f'
            '5d6c0b626ef29ce39372eb180527d64e11af2bf39a1a3e84e709464a20d2433b'
            '90993b47414cdb31bce7c12ed8e3f9a9932c74832c4b51c0a22272081dc4f4c0')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}"/${_pkgfqn}

  apply_patch_with_msg \
    qt-creator-3.2.0-Allow-iOS-plugin-on-any-platform.patch \
    qt-creator-5.0.1-fix-library-archive-path.patch \
    003-link-against-clang-cpp.patch \
    qt-creator-18.0.0-plugin-appstatisticsmonitor-define-callback.patch
}

build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  CXXFLAGS+=" -Wno-deprecated-declarations" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -GNinja \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    "${_extra_config[@]}" \
    -DWITH_DOCS=ON \
    -DBUILD_DEVELOPER_DOCS=ON \
    -DBUILD_QBS=OFF \
    -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python \
    -DWITH_TESTS=OFF \
    -DCLANGTOOLING_LINK_CLANG_DYLIB=ON \
    ../${_pkgfqn}

  ${MINGW_PREFIX}/bin/cmake --build .
  ${MINGW_PREFIX}/bin/cmake --build . --target docs
}

package_qt-creator() {
  pkgdesc="Lightweight, cross-platform integrated development environment (mingw-w64)"
  depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
           "${MINGW_PACKAGE_PREFIX}-qt6-base"
           "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
           "${MINGW_PACKAGE_PREFIX}-qt6-tools"
           "${MINGW_PACKAGE_PREFIX}-qt6-svg"
           "${MINGW_PACKAGE_PREFIX}-qt6-quick3d"
           "${MINGW_PACKAGE_PREFIX}-qt6-serialport"
           "${MINGW_PACKAGE_PREFIX}-qt6-translations"
           "${MINGW_PACKAGE_PREFIX}-libarchive"
           "${MINGW_PACKAGE_PREFIX}-litehtml"
           "${MINGW_PACKAGE_PREFIX}-yaml-cpp"
           "${MINGW_PACKAGE_PREFIX}-zstd")
  optdepends=("${MINGW_PACKAGE_PREFIX}-gdb: for the debugger"
              "${MINGW_PACKAGE_PREFIX}-cmake: CMake project support"
              "${MINGW_PACKAGE_PREFIX}-ninja: Ninja Generator"
              "${MINGW_PACKAGE_PREFIX}-qbs: QBS project support"
              "${MINGW_PACKAGE_PREFIX}-clang-libs: ClangCodeModel and ClangFormat plugins"
              "${MINGW_PACKAGE_PREFIX}-qt6-charts: Plugin AppStatisticsMonitor"
              "${MINGW_PACKAGE_PREFIX}-qt6-doc: integrated Qt6 documentation"
              "${MINGW_PACKAGE_PREFIX}-qt6-quicktimeline: qmlpuppet")

  cd "${srcdir}"/build-${MSYSTEM}

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  install -d "${pkgdir}${MINGW_PREFIX}"/share/licenses/${_realname}
  install -Dm644 "${srcdir}"/${_pkgfqn}/LICENSES/* -t "${pkgdir}${MINGW_PREFIX}"/share/licenses/${_realname}
}

package_qt-creator-docs() {
  pkgdesc="Lightweight, cross-platform integrated development environment (documentation) (mingw-w64)"
  depends=()

  cd "${srcdir}"/build-${MSYSTEM}
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install . --component qch_docs
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install . --component html_docs
}

package_qt-creator-devel() {
  pkgdesc="Lightweight, cross-platform integrated development environment (development files) (mingw-w64)"
  depends=("${MINGW_PACKAGE_PREFIX}-${_realname}")

  cd "${srcdir}"/build-${MSYSTEM}
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install . --component Devel
}

# Please leave this block here as I use
# it to quickly make and test changes.
# return 0
# Debugger ProjectExplorer 
# ALLGOOD="yes"
# PLUGINS="Debugger"
# for PLUGIN in $PLUGINS; do
#   PLUGINLC=$(echo ${PLUGIN} | tr 'A-Z' 'a-z')
#   pushd src/build-${MSYSTEM}/src/plugins/${PLUGINLC}
#     PATH=${MINGW_PREFIX}/bin:"$PATH" cmake --build . || ALLGOOD="no"
#   popd
# done
# if [ "${ALLGOOD}" = "yes" ]; then
# (
#   QTCPID=$(ps --windows | grep creator | awk '{ print $1; }')
#   while [ -n "$QTCPID" ]; do
#     cmd.exe /c "taskkill /PID $QTCPID"
#     sleep 1
#     QTCPID=$(ps --windows | grep creator | awk '{ print $1; }')
#   done
#   for PLUGIN in $PLUGINS; do
#     PLUGINLC=$(echo ${PLUGIN} | tr 'A-Z' 'a-z')
#     pushd src/build-${MSYSTEM}/src/plugins/${PLUGINLC}
#       PATH=${MINGW_PREFIX}/bin:$PATH cmake --build .
#       cp ../../../lib/qtcreator/plugins/${PLUGIN}d.dll ${MINGW_PREFIX}/lib/qtcreator/plugins/
#     popd
#   done
#   PATH=${MINGW_PREFIX}/bin:$PATH ${MINGW_PREFIX}/bin/qtcreator &
#   )
# fi
# 

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
